package models.admin.components.datasetprofile;

import java.util.LinkedList;
import java.util.List;

import org.apache.commons.lang3.RandomStringUtils;

import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlElementWrapper;

import models.components.commons.Multiplicity;
import utilities.ModelDefinition;
import utilities.ViewStyleDefinition;
import utilities.builders.ModelBuilder;

public class FieldSet implements Comparable,ModelDefinition<entities.xmlmodels.modeldefinition.FieldSet>,ViewStyleDefinition<entities.xmlmodels.viewstyledefinition.FieldSet>{
	private String id;
	private Integer ordinal;
	private Multiplicity multiplicity;
	private List<Field> fields;

	public List<Field> getFields() {
		return fields;
	}

	public void setFields(List<Field> fields) {
		this.fields = fields;
	}	

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public int getOrdinal() {
		return ordinal;
	}

	public void setOrdinal(int ordinal) {
		this.ordinal = ordinal;
	}

	public Multiplicity getMultiplicity() {
		return multiplicity;
	}

	public void setMultiplicity(Multiplicity multiplicity) {
		this.multiplicity = multiplicity;
	}

	@Override
	public entities.xmlmodels.modeldefinition.FieldSet toDatabaseDefinition(entities.xmlmodels.modeldefinition.FieldSet fieldSet) {
		if(this.id == null||this.id.isEmpty())this.id = "fieldSet_"+RandomStringUtils.random(5, true, true);

		fieldSet.setId(this.id);
		fieldSet.setOrdinal(this.ordinal);
		List<entities.xmlmodels.modeldefinition.Field> modelfields = new ModelBuilder().toModelDefinition(this.fields, entities.xmlmodels.modeldefinition.Field.class);
		fieldSet.setFields(modelfields);
		fieldSet.setMultiplicity(this.multiplicity);
		return fieldSet;
	}

	@Override
	public void fromDatabaseDefinition(entities.xmlmodels.modeldefinition.FieldSet item) {		
		this.id = item.getId();
		this.ordinal = item.getOrdinal();
		this.multiplicity = item.getMultiplicity();
	}

	@Override
	public entities.xmlmodels.viewstyledefinition.FieldSet toDatabaseDefinition(entities.xmlmodels.viewstyledefinition.FieldSet item) {	
		if(this.id == null||this.id.isEmpty())this.id = "fieldSet_"+RandomStringUtils.random(5, true, true);

		List<entities.xmlmodels.viewstyledefinition.Field> viewStylefields = new ModelBuilder().toViewStyleDefinition(this.fields, entities.xmlmodels.viewstyledefinition.Field.class);
		item.setFields(viewStylefields);
		item.setId(this.id);
		item.setOrdinal(this.ordinal);
		return item;
	}

	@Override
	public void fromDatabaseDefinition(entities.xmlmodels.viewstyledefinition.FieldSet item) {
		this.fields = new ModelBuilder().fromViewStyleDefinition(item.getFields(), Field.class);		
		this.id = item.getId();
		this.ordinal = item.getOrdinal();
	}

	@Override
	public int compareTo(Object o) {
		return this.ordinal.compareTo(((FieldSet)o).ordinal);
	}
	
	
}
