package models.properties;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlElementWrapper;

import models.components.commons.Multiplicity;
import utilities.ModelDefinition;
import utilities.ViewStyleDefinition;
import utilities.builders.ModelBuilder;

public class FieldSet implements PropertiesGenerator{	
	private List<Field> fields;
	private List<FieldSet> multiplicityItems;
		
	public List<FieldSet> getMultiplicityItems() {
		return multiplicityItems;
	}

	public void setMultiplicityItems(List<FieldSet> multiplicityItems) {
		this.multiplicityItems = multiplicityItems;
	}

	public List<Field> getFields() {
		return fields;
	}

	public void setFields(List<Field> fields) {
		this.fields = fields;
	}

	@Override
	public void toMap(Map<String, Object> fieldValues) {
		this.fields.forEach(item->item.toMap(fieldValues));
		Map<String,Object> multiplicity = new HashMap<String,Object>();
		if(this.multiplicityItems!=null){
			this.multiplicityItems.forEach(item->item.toMap(fieldValues,this.multiplicityItems.indexOf(item)));
		}
		//fieldValues.put(this.id,multiplicity);
	}

	@Override
	public void toMap(Map<String, Object> fieldValues, int index) {
		this.fields.forEach(item->item.toMap(fieldValues,index));
		//this.multiplicityItems.forEach(item->item.toMap(fieldValues,index));		
	}	

}
